CREATE OR ALTER procedure ADDSTAT (
    V_NUB_K char(10),
    V_SN_POL char(25),
    V_D_ZA date,
    V_VID_O char(1),
    V_M_OBSL char(1),
    V_D_P_USL date,
    V_SP1 char(10),
    V_SP2 char(10),
    V_D_OS char(7),
    V_TERR char(4),
    V_REZ_OB char(2),
    V_OGRN char(15),
    V_D_ZAPOL date,
    V_COMPANY char(4),
    V_NUMBER_IN_REPORT integer,
    V_ID_REPORT integer,
    V_K_MES varchar(11),
    V_MKOD char(6),
    V_DOST char(20),
    V_RMIS char(36),
    V_IDCASE integer,
    V_ST_REPEAT integer,
    V_REG_SUM numeric(18,2))
returns (
    ID_STATTALON integer)
as
BEGIN
    if (not EXISTS ( SELECT c_ogrn FROM lpu WHERE c_ogrn = :v_ogrn)) then
        select report.lpu_ogrn from report where id_report = :v_id_report into :v_ogrn;

    /* with foreign constraints checks  */
    ID_STATTALON = gen_id(gen_stattalon_id, 1);

    if (EXISTS ( SELECT id_report FROM report WHERE id_report = :v_id_report))    then
    begin

    INSERT INTO STATTALON(ID_STATTALON,
                          NUB_K,
                          SN_POL,
                          D_ZA,
                          VID_O,
                          M_OBSL,
                          D_P_USL,
                          SP1,
                          SP2,
                          D_OS,
                          TERR,
                          REZ_OB,
                          OGRN,
                          D_ZAPOL,
                          COMPANY,
                          NUMBER_IN_REPORT,
                          summ,
                          reg_summ,
                          ID_REPORT,
                          K_MES,
                          VIB,
                          MOD_YCH,
                          ME_AB,
                          MKOD,
                          OK_FIN,
                          YET,
                          age,
                          dost,
                          RMIS,
                          ID_CASE_RMIS,
                          S_SUM,
                          ST_REPEAT)
    VALUES(:ID_STATTALON,
           :v_NUB_K,
           :v_SN_POL,
           :v_D_ZA,
           :v_VID_O,
           :v_M_OBSL,
           :v_D_P_USL,
           :v_SP1,
           :v_SP2,
           :v_D_OS,
           :v_TERR,
           :v_REZ_OB,
           :v_OGRN,
           :V_D_ZAPOL,
           :v_COMPANY,
           :v_NUMBER_IN_REPORT,
           0,
           :v_reg_sum,
           :v_ID_REPORT,
           :v_k_mes,
           0,
           0,
           0,
           :V_MKOD,
           0,
           0,
           0,
           :v_dost,
           :v_rmis,
           :v_idcase,
           0,
           :v_st_repeat);
    end
        else ID_STATTALON = -1;
END
